###############################################################################
#
# PreBot Frontend TCL
# Written By Darkshadow <silentanddeadly@gmail.com>
#
###############################################################################

set Channel "#someuser"
set StatusFile "/home/someuser/prebot.status"
set AbortFile "/home/someuser/prebot.abort"
set SiteFile "/home/someuser/sites.dat"

set Prefix "[ge][u]\[[b]PreBot[b]\][u][c]"
set Blow 0
set BlowKey "fuckoff"

set PreBinary "/home/someuser/pre"
set PreTestBinary "/home/someuser/pretest"
set PreUploadBinary "/home/someuser/preupload"

###############################################################################

if {![namespace exists ::ini]} {
     source "/home/someuser/ini.tcl"
}

proc n {} {return "\n"};      # newline
proc u {} {return "\037"};    # underline
proc r {} {return "\026"};    # reverse
proc b {} {return "\002"};    # bold
proc c {} {return "\003"};    # color
proc re {} {return "\00304"}; # red
proc bl {} {return "\00312"}; # blue
proc gr {} {return "\00303"}; # green
proc ge {} {return "\00314"}; # grey

###############################################################################

bind pub P !pretest pub_pretest
bind pub P !prehqs pub_prehqs
bind pub P !preupload pub_preupload
bind pub P !prestatus pub_prestatus
bind pub P !preabort pub_preabort
bind pub P !pre pub_pre
bind pub - +OK PubBlowFishIncomingHandler
bind pub - mcps PubBlowFishIncomingHandler

###############################################################################

proc puttext {Text} {
     global BlowKey Blow Prefix

     if {$Blow == 1} {
          putserv "[lindex $Text 0] [lindex $Text 1] :+OK [encrypt $BlowKey "$Prefix [join [string trimleft [lrange $Text 2 end] :]]"]"
     } else {
          putserv "[lindex $Text 0] [lindex $Text 1] :$Prefix [join [string trimleft [lrange $Text 2 end] :]]"
     }
}

proc PubBlowFishIncomingHandler {nick host hand chan arg} {
     global BlowKey
     
     if {![info exists BlowKey]} {
          return
     }

     set Decrypt [decrypt $BlowKey $arg]   
     set Command [string tolower [string trim [lindex $Decrypt 0]]]  
     set Args [lrange $Decrypt 1 end]

     if {[string tolower $Command] == "!pre"} {pub_pre $nick $host $hand $chan $Args}
     if {[string tolower $Command] == "!pretest"} {pub_pretest $nick $host $hand $chan $Args}
     if {[string tolower $Command] == "!prehqs"} {pub_prehqs $nick $host $hand $chan $Args}
     if {[string tolower $Command] == "!preupload"} {pub_preupload $nick $host $hand $chan $Args}
     if {[string tolower $Command] == "!prestatus"} {pub_prestatus $nick $host $hand $chan $Args}
     if {[string tolower $Command] == "!preabort"} {pub_preabort $nick $host $hand $chan $Args}
     return
}

proc PubReadPipe {FilePipe} {
     global Channel

     while {[gets $FilePipe Line] != -1} {
          puttext "PRIVMSG $Channel :$Line"
     }

     if {[eof $FilePipe]} {close $FilePipe}
     return
}

proc pub_pretest {nick uhost handle chan arg} {
     global Channel PreTestBinary

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {![file exist $PreTestBinary]} {
          puttext "PRIVMSG $chan :[b][re]ERROR:[c][b] PreTest Binary Not Found"
          return
     }    

     set FilePipe [open "|$PreTestBinary $arg"]
     fconfigure $FilePipe -buffering line
     fconfigure $FilePipe -blocking 0
     fileevent $FilePipe readable [list PubReadPipe $FilePipe]
     return
}

proc pub_prehqs {nick uhost handle chan arg} {
     global Channel SiteFile

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {![file exist $SiteFile] || [file size $SiteFile] == 0} {
          puttext "PRIVMSG $chan :[b][re]ERROR:[c][b] No Sites Have Been Added!"
          return
     }    
     
     set Ini [ini::open $SiteFile r]

     foreach Site [ini::sections $Ini]  {
          if {[ini::exists $Ini $Site Enabled] && [ini::exists $Ini $Site Online]} {
               if {[ini::value $Ini $Site Enabled] == 1} {          
                    if {[ini::value $Ini $Site Online] == 1} {          
                         if {[info exists Online]} {lappend Online [string toupper $Site]} else {set Online [list [string toupper $Site]]}
                    } else {
                         if {[info exists Offline]} {lappend Offline [string toupper $Site]} else {set Offline [list [string toupper $Site]]}
                    }
               }
          }
     }

     ini::close $Ini

     if {[info exists Online] && [info exists Offline]} {
          puttext "PRIVMSG $chan :Sites Online: [gr][b]$Online[b][c], Offline: [re][b]$Offline[b][c]"
     } elseif {[info exists Online]} {
          puttext "PRIVMSG $chan :Sites Online: [gr][b]$Online[b][c]"
     } elseif {[info exists Offline]} {
          puttext "PRIVMSG $chan :Sites Offline: [re][b]$Offline[b][c]"
     }

     return
}

proc pub_preupload {nick uhost handle chan arg} {
     global Channel PreUploadBinary

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {![file exist $PreUploadBinary]} {
          puttext "PRIVMSG $chan :[b][re]ERROR:[c][b] PreUpload Binary Not Found"
          return
     }    

     set FilePipe [open "|$PreUploadBinary $arg"]
     fconfigure $FilePipe -buffering line
     fconfigure $FilePipe -blocking 0
     fileevent $FilePipe readable [list PubReadPipe $FilePipe]
     return
}

proc pub_pre {nick uhost handle chan arg} {
     global Channel PreBinary

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {![file exist $PreBinary]} {
          puttext "PRIVMSG $chan :[b][re]ERROR:[c][b] Pre Binary Not Found"
          return
     }    

     set FilePipe [open "|$PreBinary $arg"]
     fconfigure $FilePipe -buffering line
     fconfigure $FilePipe -blocking 0
     fileevent $FilePipe readable [list PubReadPipe $FilePipe]
     return
}

proc pub_prestatus {nick uhost handle chan arg} {
     global Channel StatusFile

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {[file exist $StatusFile]} {
          set ReadFile [open $StatusFile r]
          set Status [gets $ReadFile]
          close $ReadFile
          puttext "PRIVMSG $nick :Current Status: $Status"
     } else {
          puttext "PRIVMSG $nick :PreStatus File Not Found, Maybe Not In Process"
     } 

     return
}

proc pub_preabort {nick uhost handle chan arg} {
     global Channel AbortFile

     if {[string tolower $chan] != [string tolower $Channel]} {
          return
     }

     if {[file exist $StatusFile]} {
          puttext "PRIVMSG $nick :Abort Files Already Exists"
     } else {
          #set OutFile [open $AbortFile w]
          #close $OutFile
          puttext "PRIVMSG $nick :Not Coded YET!"
          #puttext "PRIVMSG $nick :Abort File Created PreBot Should Abort Current Process Shortly..."
     } 

     return
}

putlog "PreBot Frontend TCL Loaded!"

###############################################################################
